<?php

/**
* @copyright	Copyright (C) 2009 - 2012 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	easydiscuss
* @contact		payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Easydiscuss Plugin
 *
 */
class PayplansAppEdbadges extends PayplansApp
{
	public $_location       = __FILE__;
	protected $_resource	= 'com_easydiscuss.badge';
	
    public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_easydiscuss');
	}

	public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if(($new->getStatus() == PayplansStatus::NONE) || ($prev != null && $prev->getStatus() == $new->getStatus())){
			return true;
	    }

		$newStatus  = $new->getStatus();
		
		$userid       = $new->getBuyer();
		$subid        = $new->getId();
		$buyer_name   = $new->getBuyerName();
		$plan         = $new->getTitle();
		$badges       = $this->getAppParam('badges');
	    $badges       = is_array($badges) ? $badges : array($badges);
		
		
	    if($newStatus == PayplansStatus::SUBSCRIPTION_ACTIVE){
	     	$badge = $this->addIntoBadge($userid, $badges);
		    foreach ($badge as $badge_id) {
		        $this->_addToResource($subid, $userid, $badge_id, $this->_resource);
		    }
	    }
	    else {
	        $badgevalues = $this->_getBadgeValues($userid, $subid);
	        $this->_deleteFromBadge($userid, $badgevalues);
	        foreach ($badgevalues as $badgevalue) {
	           $this->_removeFromResource($subid, $userid, $badgevalue, $this->_resource);
	        }
	    } 
		return true;
     }
	
	public function addIntoBadge($userid, $badges)
    {
    	$badge_ids = array();
		foreach ($badges as $badge_id){
				$db    = PayplansFactory::getDBO();
				$query = 'insert into `#__discuss_badges_users` (`badge_id`,`user_id`,`published`) VALUES ('
						.$badge_id.','.$userid.',1)';
						
				$db->setQuery($query);
				$db->query();
				$badge_ids[] = $db->insertid();
		}
		
		return $badge_ids;
	}	
	
	protected function _getBadgeValues($userid, $subid)
	{
		$db    = PayplansFactory::getDbo();
		$query =  'SELECT `value`'
			 	. ' FROM `#__payplans_resource`'
			 	. ' WHERE `user_id`        = ' . $userid
			    . ' AND `subscription_ids` ='."'".','.$subid.','."'";
			   
	    	    
	    $db->setQuery( $query );
        return $db->loadColumn();         
	}
	
	protected function _deleteFromBadge($userid, $badgevalues)
	{
		if (empty($badgevalues)){
			return true;
		}
		
		$badgevalues = implode(',', $badgevalues);
		
		$db    = PayplansFactory::getDbo();
		$query = 'DELETE FROM #__discuss_badges_users'
			. ' WHERE `id` IN ('. $badgevalues .')' ;
		
		$db->setQuery( $query );
		return $db->query();
	}

	public function renderWidgetHtml()
	{	
	    $userid     = XiFactory::getUser()->id;
		if(!$userid){
			return '';
		}
		//get user's easydiscuss categories
	    $easydiscuss_badges = $this->_getAllowedBadges($userid);
	    if(empty($easydiscuss_badges)){
	    	return '';
	    }
	    $this->assign('easydiscuss_badges',$easydiscuss_badges);
        $data = $this->_render('widgethtml');
        return $data;
	}	
	
	protected function _getAllowedBadges($userid)
	{
	     $db    = PayplansFactory::getDbo();
		 $query = 'SELECT a.id, a.title'
			 	. ' FROM #__discuss_badges AS a'
			 	. ' LEFT JOIN #__discuss_badges_users AS b'
			 	. ' ON a.id = b.badge_id'
			 	. ' WHERE b.user_id = '. $userid ;
			 	 	
	     $db->setQuery( $query );
         return $db->loadObjectList();         	
	}
	
    protected function _getTitle($badges)
	{
		$badges = implode(',', $badges);
		
		$db    = PayplansFactory::getDbo();
		$query = 'SELECT `title`'
			 	 .'FROM #__discuss_badges'
			 	. ' WHERE `id` IN('.$badges.')';
			 	
	    $db->setQuery( $query );
        return $db->loadColumn(); 
	}
}
 
class PayplansAppEdbadgesFormatter extends PayplansAppFormatter
{
	//get Rules 
	function getVarFormatter()
	{
		$rules = array();
		return $rules;
	}	
 }
